' Creates individual "html" web pages for a slide 
' show of your pictures, text, and sound files (or any combination of 
' those three). You MUST have your file names chosen so they'll be in the 
' correct order. All related files MUST have the same base names.

Option Explicit

Main

Sub Main()
Dim strTextExtension, strPath, strTextFile
Dim strPictureExtensions, strPictureExtension
Dim strBigPictureFile, strBigPictureUrl, strBigPictureExtensions
Dim strPictureUrl, strPictureFile
Dim strSoundExtensions, strSoundExtension, strSoundUrl, strSoundFile
Dim strHtmSuffix, strHtmFile, strHtmName
Dim strTitle, strContent, strBaseName, strHomeUrl
Dim strPrevious, strNext
Dim strDefault, strPrompt
Dim blnZero, blnThumbnails
Dim intCount
Dim fs, fol, fils, fil, list()
	'Notify user
	If MsgBox("This script creates and edits files. If your computer warns you about these actions, you should allow them." & vbCrLf & "NOTE: This script only works on files in a single folder of your choosing. To succeed, all related files in that folder must have identical base names (for example foo.jpg, foo.jpeg, foo.txt, and foo.mp3).", vbOkCancel, WScript.ScriptName) = vbCancel Then
		Exit Sub
	End If
	
	'Register the FileSystem object
	If Not ((IsRegistered("Scripting.FileSystemObject")) And (IsRegistered("Wscript.Shell"))) Then
		If MsgBox ("You seem to have a bad or old installation of Microsoft Windows Scripting. I'd like to take you to a Microsoft web page where you can download Scripting Version 5.6. May I launch your browser to take you to the download page?", vbYesNo, "Update Needed") = vbYes Then
			Select Case OsVersion()
				Case 0
					ws.Run "http://msdn.microsoft.com/downloads/list/webdev.asp?frame=true", 1, False
				Case 5
					ws.Run "http://www.microsoft.com/downloads/details.aspx?FamilyId=C717D943-7E4B-4622-86EB-95A22B832CAA&displaylang=en", 1, False
				Case Else
					ws.Run "http://www.microsoft.com/downloads/details.aspx?FamilyId=0A8A18F6-249C-4A72-BFCF-FC6AF26DC390&displaylang=en", 1, False
			End Select
		End If
		MsgBox "After you (or your administrator) are done updating Scripting, you can re-run this program."
		Exit Sub
	End If
	Set fs = CreateObject("Scripting.FileSystemObject")
	
	'Select the folder for processing
	strPath = ""
	If WScript.Arguments.Count = 1 Then
		If fs.FolderExists(WScript.Arguments(0)) Then
			strPath = WScript.Arguments(0)
		End If
	End If
	If strPath = "" Then strPath = BrowseForFolder("Slide Show Content Location:") 
	If strPath = "" Then Exit Sub

	strHtmSuffix = ".html"
	strHtmSuffix = InputBox("What file extension should the generated web pages have (For example htm or html)?", "Web Page Suffix", strHtmSuffix)
	If strHtmSuffix = "" Then Exit Sub
	If Left(strHtmSuffix, 1) <> "." Then strHtmSuffix = "." & strHtmSuffix
	
	strTextExtension = ".txt"
	strTextExtension = InputBox("If you have plain text files in your chosen folder you'd like incorporated into your presentation, what extension do they have?" & vbCrLf & "Note: You can hit ""Cancel"" if you have no text files.", "Text File Suffix", strTextExtension)
	If strTextExtension = "" Then strTextExtension = ".............."
	If Left(strTextExtension, 1) <> "." Then strTextExtension = "." & strTextExtension

	strPictureExtensions = ".jpg, .jpeg, .png"
	strPictureExtensions = InputBox("If you have pictures in your chosen folder you'd like incorporated into your presentation, what extension(s) do they have?" & vbCrLf & "NOTE: If you have duplicate hi-res pictures or thumbnails in the same folder, DON'T list those file extensions here.", "Picture Suffix", strPictureExtensions)
	If strPictureExtensions = "" Then strPictureExtensions = ".............."
	If Left(strPictureExtensions, 1) <> "." Then strPictureExtensions = "." & strPictureExtensions

	strBigPictureExtensions = ".jp2, .tiff, .raw, .zip"
	strBigPictureExtensions = InputBox("If you have high-resolution pictures or other content in your chosen folder you'd like to be linked to your normal pictures, what extension(s) do they have?" & vbCrLf & "Note: You can enter the same extensions you previously chose for your pictures (" & strPictureExtensions & ") to have them link to themselves, or you can hit ""Cancel"" if you don't want any linked content.", "Picture-Linked Content Suffix", strBigPictureExtensions)
	If strBigPictureExtensions = "" Then strBigPictureExtensions = ".............."
	If Left(strBigPictureExtensions, 1) <> "." Then strBigPictureExtensions = "." & strBigPictureExtensions

	strSoundExtensions = ".wma, .wav, .mp3,"
	strSoundExtensions = InputBox("If you have sound files in your chosen folder you'd like incorporated into your presentation, what extension(s) do they have?" & vbCrLf & "Note: you can hit ""Cancel"" if you don't have any sound files.", "Sound File Suffix", strSoundExtensions)
	If strSoundExtensions = "" Then strSoundExtensions = ".............."
	If Left(strSoundExtensions, 1) <> "." Then strSoundExtensions = "." & strSoundExtensions

	'Get the title
	If ((Len(fs.GetBaseName(strPath)) > 2) And (Instr(fs.GetBaseName(strPath), " ") = 0)) Then
		strTitle = Left(fs.GetBaseName(strPath), 1)
		For intCount = 2 To Len(fs.GetBaseName(strPath))
			If InStr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(fs.GetBaseName(strPath), intCount, 1)) <> 0 Then
				strTitle = strTitle & " " & Mid(fs.GetBaseName(strPath), intCount, 1)
			Else
				strTitle = strTitle & Mid(fs.GetBaseName(strPath), intCount, 1)
			End If
		Next
	Else
		strTitle = fs.GetBaseName(strPath)
	End If
	strTitle = InputBox("Enter the title for this presentation:", "Title", strTitle)
	
	'Get the home URL
	strHomeUrl = InputBox("If the user presses the ""home"" button (or finishes the presentation), what URL should they go to? Common answers are ""./"" for an index page in the presentation directory, ""../"" for the parent directory, and ""/"" for the hosting site's home page.", "Index Page", "./")
	If strHomeUrl = "" Then Exit Sub

	'Create a "master" list of the defining file: picture, text, or audio (in that order)
	'Check all files in the picture directory
	Set fol = fs.GetFolder(strPath)
	Set fils = fol.Files
	ReDim list(0)
	blnZero = True
	Status "Reading picture file names..."
	For Each fil In fils
		For Each strPictureExtension In Split(strPictureExtensions, ",")
			strPictureExtension = Trim(strPictureExtension)
			If Left(strPictureExtension, 1) <> "." Then strPictureExtension = "." & strPictureExtension
			If Lcase(Right(fil.Name, Len(Trim(strPictureExtension))))  = Lcase(Trim(strPictureExtension)) Then
				'It's a picture. Add it to our list
				Status vbTab & fil.Name
				If Not blnZero Then ReDim Preserve list(UBound(list) + 1)
				blnZero = False
				list(UBound(list)) = fil.name
				Exit For
			End If
		Next
	Next
	'Check text directory
	Set fol = fs.GetFolder(strPath)
	Set fils = fol.Files
	If Left(strTextExtension, 1) <> "." Then strTextExtension = "." & strTextExtension
	Status "Reading text file names..."
	For Each fil In fils
		If Lcase(Right(fil.Name, Len(Trim(strTextExtension)))) = Lcase(Trim(strTextExtension)) Then
			'It's text.
			Status vbTab & fil.Name
			If Not BaseNameInArray(list, fil.Name) Then
				'There's no picture by that name; add the text file to the list
				If Not blnZero Then ReDim Preserve list(UBound(list) + 1)
				blnZero = False
				list(UBound(list)) = fil.name
			End If
		End If
	Next
	'Check sound directory
	Set fol = fs.GetFolder(strPath)
	Set fils = fol.Files
	Status "Reading sound file names..."
	For Each fil In fils
		For Each strSoundExtension In Split(strSoundExtensions, ",")
			strSoundExtension = Trim(strSoundExtension)
			If Left(strSoundExtension, 1) <> "." Then strSoundExtension = "." & strSoundExtension
			If Lcase(Right(fil.Name, Len(Trim(strSoundExtension)))) = Lcase(Trim(strSoundExtension)) Then
				'It's sound.
				Status vbTab & fil.Name
				If Not BaseNameInArray(list, fil.Name) Then
					'There's no picture or text by that name; add the sound file to the list
					If Not blnZero Then ReDim Preserve list(UBound(list) + 1)
					blnZero = False
					list(UBound(list)) = fil.name
					Exit For
				End If
			End If
		Next
	Next
	'Sort the list
	Status "Sorting names..."
	SortAscending list, "*", 0
	
	'Create the content
	Status "Creating files..."
	For intCount = LBound(list) To UBound(list)
		strBaseName = fs.GetBaseName(list(intCount))
		'Get the file name of the text file
		strTextFile = FileNameIfExists(strBaseName, strTextExtension, strPath)
		If strTextFile <> "" Then
			strTextFile = fs.BuildPath(strPath, strTextFile)
		End If
		'Get the URL for the picture
		strPictureFile = FileNameIfExists(strBaseName, strPictureExtensions, strPath)
		If strPictureFile = "" Then
			strPictureUrl = ""
		Else
			strPictureUrl = strPictureFile
		End If
		'Get the URL for the BIG picture
		strBigPictureFile = FileNameIfExists(strBaseName, strBigPictureExtensions, strPath)
		If strBigPictureFile = "" Then
			strBigPictureUrl = ""
		Else
			strBigPictureUrl = strBigPictureFile
		End If
		'Get the URL for the sound
		strSoundFile = FileNameIfExists(strBaseName, strSoundExtensions, strPath)
		If strSoundFile = "" Then
			strSoundUrl = ""
		Else
			strSoundUrl = strSoundFile
		End If
		'Get the name of the HTM file we'll be constructing
		strHtmName = fs.BuildPath(strPath, strBaseName & strHtmSuffix)
		'Get the Previous URL for navigation purposes
		If intCount = LBound(list) Then
			strPrevious = strHomeUrl
		Else
			strPrevious = fs.GetBaseName(list(intCount - 1)) & strHtmSuffix
		End If
		'Get the Next URL for navigation purposes
		If intCount = UBound(list) Then
			strNext = strHomeUrl
		Else
			strNext = fs.GetBaseName(list(intCount + 1)) & strHtmSuffix
		End If
		strContent = "<html>"
		strContent = strContent & vbCrLf & "<head><title>" & strTitle & "</title></head>"
		strContent = strContent & vbCrLf & "<body>"
		strContent = strContent & vbCrLf & "<table border='0' width='100%'>"
		strContent = strContent & vbCrLf & "<tr>"
		strContent = strContent & vbCrLf & "<td valign='top' align='left'>" & NavCode(strPrevious, strHomeUrl, strNext) & "</td>"
		strContent = strContent & vbCrLf & "<td valign='top' align='right'>" & PlayerCode(strSoundUrl) & "</td>"
		strContent = strContent & vbCrLf & "</tr>"
		strContent = strContent & vbCrLf & "</table>"
		strContent = strContent & vbCrLf & ContentCode(strTextFile, strPictureUrl, strBigPictureUrl)
		strContent = strContent & vbCrLf & "</body>"
		strContent = strContent & vbCrLf & "</html>"
		String2File strContent, strHtmName
	Next
	
	'Let them know it's done
	WScript.Echo "Files have been created for a web-based slide show. Your first page should be ""index" & strHtmSuffix & """."
End Sub

Function MatchesExtension(strFileName, strExtensions)
Dim strExtension, blnMatchesExtension
	blnMatchesExtension = False
	For Each strExtension In Split(strExtensions, ",")
		If Left(strExtension, 1) <> "." Then strExtension = "." & strExtension
		If Lcase(Right(strFileName, Len(Trim(strExtension)))) = Lcase(Trim(strExtension)) Then
			blnMatchesExtension = True
			Exit For
		End If
	Next
	MatchesExtension = blnMatchesExtension
End Function

Function FileNameIfExists(strBaseName, strExtensions, strPath)
Dim fs, fol, fils, fil, strExtension, intCount
	Set fs = CreateObject("Scripting.FileSystemObject")
	For Each strExtension In Split(strExtensions, ",")
		strExtension = Trim(strExtension)
		If Left(strExtension, 1) <> "." Then strExtension = "." & strExtension
		If fs.FileExists(fs.BuildPath(strPath, strBaseName & strExtension)) Then
			FileNameIfExists = fs.GetFile(fs.BuildPath(strPath, strBaseName & strExtension)).Name
			Exit Function
		End If
	Next
	FileNameIfExists = ""
End Function

Function BaseNameInArray(varArray, strFileName)
Dim fs, strElement, strBase, blnInArray
	Set fs = CreateObject("Scripting.FileSystemObject")
	blnInArray = False
	strBase = Lcase(fs.GetBaseName(strFileName))
	For Each strElement In varArray
		If Lcase(fs.GetBaseName(strElement)) = strBase Then
			blnInArray = True
			Exit For
		End If
	Next
	BaseNameInArray = blnInArray
End Function
	
Sub AppendToFile(strFile, strText)
Dim fs 'As Scripting.FileSystemObject
Dim ts 'As Scripting.TextStream
Const ForAppending = 8
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set ts = fs.OpenTextFile(strFile, ForAppending, True)
	ts.Write strText
	ts.Close
End Sub

Sub SortAscending(strArray, strSplitCharacter, intSortByElement)
Dim blnChanged 'As Boolean
Dim strBuffer 'As String
Dim intCounter 'As Integer
	blnChanged = True
	Do Until Not blnChanged
		blnChanged = False
		For intCounter = Lbound(strArray) + 1 to Ubound(strArray)
			If Split(strArray(intCounter -1), strSplitCharacter)(intSortByElement) > Split(strArray(intCounter), strSplitCharacter)(intSortByElement) Then
				blnChanged = True
				strBuffer = strArray(intCounter -1)
				strArray(intCounter -1) = strArray(intCounter)
				strArray(intCounter) = strBuffer
			End If
		Next
	Loop
End Sub

Sub String2File(strData, strFileName)
'Writes a string to a file
Dim fs 'As Scripting.FileSystemObject
Dim ts 'As Scripting.TextStream
Dim lngChar, strBlock, intChar
Const ForWriting = 2
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set ts = fs.OpenTextFile(strFileName, ForWriting, True)
	Err.Clear
	On Error Resume Next
	ts.Write strData
	If Err.Number <> 0 Then
		'Must have hit one of the "problem characters" between 128 and 159
		For lngChar = 1 To Len(strData) Step 100
			Err.Clear
			ts.Write Mid(strData, lngChar, 100)
			If Err.Number <> 0 Then
				'This block of 100 must have the problem. Write them one-at-a-time
				strBlock = Mid(strData, lngChar, 100)
				For intChar = 1 To Len(strBlock)
					ts.Write Chr(255 And AscW(Mid(strBlock, intChar)))
				Next
			End If
		Next
	End If
	ts.Close
End Sub

Function File2String(strFile) 'As String
Dim fs 'As Scripting.FileSystemObject
Dim ts 'As Scripting.TextStream
Const ForReading = 1
	Set fs = CreateObject("Scripting.FileSystemObject")
	If fs.FileExists(strFile) Then
		Set ts = fs.OpenTextFile(strFile, ForReading, True)
		If ts.AtEndOfStream Then
			File2String =""
		Else
			File2String = ts.ReadAll
		End If
		ts.Close
	Else
		File2String = ""
	End If
End Function

Function Text2Html(strRawData) 'As String
'Makes raw text safe to display on a web page
Dim strText2Html 'As String
	strText2Html = strRawData
	strText2Html = Replace(strText2Html, "<", "&lt;")
	strText2Html = Replace(strText2Html, ">", "&gt;")
	strText2Html = Replace(strText2Html, "&", "&amp;")
	strText2Html = Replace(strText2Html, vbCrLf & vbCrLf, vbCrLf & "<p>" & vbCrLf)
	strText2Html = Replace(strText2Html, vbCr & vbCr, vbCrLf & "<p>" & vbCrLf)
	strText2Html = Replace(strText2Html, vbLf & vbLf, vbCrLf & "<p>" & vbCrLf)
	strText2Html = Replace(strText2Html, vbTab, "&nbsp;&nbsp;&nbsp;&nbsp;")
	strText2Html = Replace(strText2Html, "  ", "&nbsp;&nbsp;")
	Text2Html = strText2Html
End Function

Function PlayerCode(strAudioUrl)
Dim strBuffer
	If strAudioUrl = "" Then
		strBuffer = "&nbsp;"
	Else
		strBuffer = ""
		strBuffer = strBuffer & vbCrLf & "<OBJECT ID=""MediaPlayer"" width=""144"" height=""45"""
		strBuffer = strBuffer & vbCrLf & "	classid=""CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95"""
		strBuffer = strBuffer & vbCrLf & "	CODEBASE=""http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,4,5,715"""
		strBuffer = strBuffer & vbCrLf & "	standby=""Loading Microsoft Windows Media Player components..."""
		strBuffer = strBuffer & vbCrLf & "	type=""application/x-oleobject"">"
		strBuffer = strBuffer & vbCrLf & "	<PARAM NAME=""FileName"" VALUE=""" & strAudioUrl & """>"
		strBuffer = strBuffer & vbCrLf & "	<PARAM NAME=""ShowControls"" VALUE=""True"">"
		strBuffer = strBuffer & vbCrLf & "	<EMBED type=""application/x-mplayer2"""
		strBuffer = strBuffer & vbCrLf & "		pluginspage=""http://www.microsoft.com/windows/windowsmedia/download/plugin.aspx"""
		strBuffer = strBuffer & vbCrLf & "		height=""45"" width=""144"""
		strBuffer = strBuffer & vbCrLf & "		src=""" & strAudioUrl & """"
		strBuffer = strBuffer & vbCrLf & "		autostart=""True"" autoplay=""True"""
		strBuffer = strBuffer & vbCrLf & "		showcontrols=""1"""
		strBuffer = strBuffer & vbCrLf & "		visible=""True"" hidden=""False"">"
		strBuffer = strBuffer & vbCrLf & "	</EMBED>"
		strBuffer = strBuffer & vbCrLf & "</OBJECT>"
	End If
	PlayerCode = strBuffer
End Function

Function NavCode(strPrevious, strHomeUrl, strNext)
Dim strBuffer
	strBuffer = ""
	strBuffer = strBuffer & vbCrLf & "<font size=+2><a style='text-decoration:none' "
	If strPrevious = strHomeUrl Then
		strBuffer = strBuffer & "target='_top' " 'Break out of frames when going home
	End If
	strBuffer = strBuffer & "href='" & strPrevious & "' title='Previous'>&#9668;</a></font>&nbsp;"
	strBuffer = strBuffer & vbCrLf & "<font size=+2><a style='text-decoration:none' "
	strBuffer = strBuffer & "target='_top' " 'Break out of frames when going home
	strBuffer = strBuffer & "href='" & strHomeUrl & "' title='Home'>&#9788;</a></font>&nbsp;"
	strBuffer = strBuffer & vbCrLf & "<font size=+2><a style='text-decoration:none' "
	If strNext = strHomeUrl Then
		strBuffer = strBuffer & "target='_top' " 'Break out of frames when going home
	End If
	strBuffer = strBuffer & "href='" & strNext & "' title='Next' id='Next' name='Next'>&#9658;</a></font>&nbsp;"
	strBuffer = strBuffer & "<script>setTimeout('document.getElementById(""Next"").focus()', 1000)</script>"
	NavCode = strBuffer
End Function

Function ContentCode(strTextFilePath, strPictureUrl, strBigPictureUrl)
Dim strBuffer
	strBuffer = ""
	If strPictureUrl <> "" Then
		strBuffer = strBuffer & vbCrLf
		If strBigPictureUrl <> "" Then
			strBuffer = strBuffer & "<a href=""" & strBigPictureUrl & """>"
		End If
		strBuffer = strBuffer & "<img src=""" & strPictureUrl & """ align=""right"" "
		If strBigPictureUrl <> "" Then
			strBuffer = strBuffer & "border=""0""></a>"
		Else 
			strBuffer = strBuffer & ">"
		End If
	End If
	If ((strPictureUrl <> "") And (strTextFilePath <> "")) Then
		strBuffer = strBuffer & vbCrLf & "<img height=1 width=100><br> "
		'strBuffer = strBuffer & vbCrLf & "<![if lt IE 5]><img height=1 width=200><br> <![endif]>"
		'strBuffer = strBuffer & vbCrLf & "<!--[if gte IE 5]><br clear=all><![endif]-->"
	End If
	If strTextFilePath <> "" Then
		strBuffer = strBuffer & vbCrLf & Text2Html(File2String(strTextFilePath))
	End If
	ContentCode = strBuffer
End Function

Function IsRegistered(strObjectName)
'Returns True if object can be created
Dim obj
On Error Resume Next
	Set obj = Nothing
	Set obj = CreateObject(strObjectName)
	If obj Is Nothing Then
		IsRegistered = False
	Else
		IsRegistered = True
		Set obj = Nothing
	End If
End Function

Function FileNameInThisDir(strFileName) 'As String
'Returns the complete path and file name to a file in
'the script directory. For example, "trans.log" might
'return "C:\Program Files\Scripts\Database\trans.log"
'if the script was in the "C:\Program Files\Scripts\Database"
'directory.
Dim fs 'As Object
	Set fs = CreateObject("Scripting.FileSystemObject")
	 FileNameInThisDir = fs.GetAbsolutePathName(fs.BuildPath(Wscript.ScriptFullName, "..\" & strFileName))
	''''''''''Clean up
	Set fs = Nothing
End Function

Function BrowseForFolder(strPrompt)
'Uses the "Shell.Application" (only present in Win98 and newer)
'to bring up a file/folder selection window. Falls back to an
'ugly input box under Win95.
'Shell32.ShellSpecialFolderConstants
Const ssfPERSONAL = 5 'My Documents
Const ssfDRIVES = 17 'My Computer
Const SFVVO_SHOWALLOBJECTS = 1
Const SFVVO_SHOWEXTENSIONS = 2 
	Dim sh, fol, fs, lngView, strPath
	Set sh = CreateObject("Shell.Application")
	If Instr(TypeName(sh), "Shell") = 0 Then
		BrowseForFolder = InputBox(strPrompt, "Select Folder", CreateObject("Scripting.FileSystemObject").GetParentFolderName(WScript.ScriptFullName))
		Exit Function
	End If
	Set fs = CreateObject("Scripting.FileSystemObject")
	lngView = SFVVO_SHOWALLOBJECTS Or SFVVO_SHOWEXTENSIONS
	strPath = ""
	Set fol = sh.BrowseForFolder(&0, strPrompt, lngView, ssfDRIVES)
	Err.Clear
	On Error Resume Next
	strPath = fol.ParentFolder.ParseName(fol.Title).Path
	'An error occurs if the user selects a drive instead of a folder
	If Err.Number <> 0 Then
		BrowseForFolder = Left(Right(fol.Title, 3), 2) & "\"
	Else
		BrowseForFolder = strPath
	End If
End Function

Function OsVersion()
	'Returns the base number for the OS (4 = Win9x, 5 = 2K/XP, 0 = unknown)
	Dim lngVersion, strVersion, objWMI, colSystems, objOS
	On Error Resume Next
	Err.Clear
	Set objWMI = GetObject("winmgmts:\\.\root\CIMV2")
	Set colSystems = objWMI.ExecQuery("SELECT * FROM Win32_OperatingSystem", "WQL", 48)
	For Each objOS In colSystems
		strVersion = objOS.Version
	Next
	If Err.Number <> 0 Then
		strVersion = "4" 'Assume lack of WMI means Windows 9X
	End If
	If InStr(strVersion, ".") > 1 Then
		strVersion = Left(strVersion, InStr(strVersion, ".") - 1)
	End If
	If IsNumeric(strVersion) Then
		lngVersion = Clng(strVersion)
	Else
		lngVersion = 0
	End If
	OsVersion = lngVersion
	Set objWMI = Nothing
End Function

Sub Status(strMessage)
	If Lcase(Right(Wscript.FullName, 12)) = "\cscript.exe" Then
		Wscript.Echo strMessage
	End If
End Sub
